<?php
/****************************************************************************
* ExBB v.1.7                                                              	*
* Copyright (c) 2002-20 by Alexander Subhankulov aka Warlock            	*
*                                                                         	*
* http://www.exbb.net                                             			*
* email: admin@exbb.net                                           			*
*                                                                         	*
****************************************************************************/
/****************************************************************************
*                                                                         	*
*   This program is free software; you can redistribute it and/or modify  	*
*   it under the terms of the GNU General Public License as published by  	*
*   the Free Software Foundation; either version 2 of the License, or     	*
*   (at your option) any later version.                                   	*
*                                                                         	*
****************************************************************************/

function checkuser($un) {
		global $exbb;

  		if (file_exists($exbb['home_path'].'members/'.$un.'.php')) {return true;}
  		return false;
}

function getmember($un) {
		global $exbb;

  		if (checkuser($un)) {
    		$userfile = $exbb['home_path'].'members/'.$un.'.php';
    		return get_file($userfile,FALSE);
  		}
  		return false;
}

function checkadmin () {
    	global $exbb;
    	if (isset($_SESSION['admin']) && $_SESSION['admin'] === TRUE && isset($_SESSION['admin_lasttime']) &&  $_SESSION['admin_lasttime'] > (time() - $exbb['ad_sestime'])) {
    		$_SESSION['admin_lasttime'] = time();
			define("ADMIN_LOGGED", TRUE);
		} else {
      			unset($_SESSION['admin'],$_SESSION['admin_lasttime']);
    	}
    	return;
}

function checklgn() {
		global $exbb;
  		if (isset($_SESSION['iden']) && isset($_SESSION['mid']) && $_SESSION['mid'] != 0) {
    		return true;
  		} elseif (isset($_SESSION['mid']) && $_SESSION['mid'] == 0) {
  				$_SESSION['mid'] = 0;
  				return false;
  		} else { //first run
    			$id_cookie = (isset($_COOKIE['exbbn'])) ? (int) $_COOKIE['exbbn'] : 0;
    			$pass_cookie = (isset($_COOKIE['exbbp'])) ? $_COOKIE['exbbp'] : '';
    			if ( (!empty($id_cookie)) and (!empty($pass_cookie)) ) {
      				$inuser = getmember($id_cookie);
    			}
           	 	$now_time = time();
            	if (is_array($inuser) and $pass_cookie == md5($inuser['pass'])) {
                	if ($inuser['status'] == 'banned') error('Denial of access','You are banned!');
       				$_SESSION['mid']			= (int) $inuser['id'];
       				$_SESSION['sts']			= $inuser['status'];
       				$_SESSION['us_time']		= intval($inuser['timedif']);
       				$_SESSION['lastposttime'] 	= isset($inuser['lastpost']['date']) ? $inuser['lastpost']['date'] : $now_time-180;
       				$_SESSION['last_visit'] 	= isset($inuser['last_visit']) ? (int)$inuser['last_visit'] : $now_time;
       				$_SESSION['iden']			= md5($inuser['name'].$inuser['pass'].$exbb['sesid']);
       				my_setcookie('exbbn',$inuser['id']);
       				my_setcookie('exbbp',md5($inuser['pass']));
       				my_setcookie('lastvisit',$inuser['last_visit']);

       				access_log($inuser['name']);
       				return true;
    			} else {
        				$_SESSION					= array();
        				$_SESSION['mid']			= 0;
        				$_SESSION['us_time']		= 0;
        				$_SESSION['lastposttime']	= $now_time-180;
        				$_SESSION['last_visit']		= isset($_COOKIE['lastvisit']) ? (int) $_COOKIE['lastvisit'] : $now_time;
        				my_setcookie('lastvisit',time());
        				access_log();
        				return false;
    			}
  		  } //is first run
}

function access_log($user = 'Guest') {
		global $exbb,$vars;
		if ( !$exbb['log'] ) return;
  		if (!isset($vars['IP_ADDRESS'])) {
     	$vars['IP_ADDRESS'] = select_var( array(
                                            1 => $_SERVER['REMOTE_ADDR'],
                                            2 => $_SERVER['HTTP_X_FORWARDED_FOR'],
                                            3 => $_SERVER['HTTP_PROXY_USER']
                                              )
                                       );


     $vars['IP_ADDRESS'] = preg_replace( "/^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})/", "\\1.\\2.\\3.\\4", $vars['IP_ADDRESS'] );

  }
  $fp = @fopen($exbb['home_path'].'data/access_log.php','a');
  @flock($fp,2);
  @fwrite($fp,date("d.m.y - H:i:s",time()).' :: '.$user.' :: '.$vars['IP_ADDRESS']."\n");
  @fclose($fp);
	return;

}

function user_locale($userinfo = array()) {

  global $exbb,$lang;

        $l = $exbb['default_lang'];
        $s =  $exbb['default_style'];

        if (isset($userinfo['lang']) && !empty($userinfo['lang'])) $exbb['default_lang'] = $userinfo['lang'];
        if (isset($userinfo['skin']) && !empty($userinfo['skin'])) $exbb['default_style'] = $userinfo['skin'];

        if ( !file_exists($exbb['home_path'] . 'language/' . $exbb['default_lang'] . '/lang.php') )
        {
                $exbb['default_lang'] = $l;
        }

        if ( !file_exists($exbb['home_path'] . 'templates/' . $exbb['default_style'] . '/board_body.tpl') )
        {
                $exbb['default_style'] = $s;
        }

        if (defined('IN_ADMIN'))
        {
                if( !file_exists($exbb['home_path'] .'language/' . $exbb['default_lang'] . '/lang_admin.php') )
                {
                        $exbb['default_lang'] = 'russian';
                }

                include('./language/' . $exbb['default_lang'] . '/lang_admin.php');
        }

        return;
}

function parsed_vars() {

 $return = array();

 if ( is_array($_GET) ) {

   while( list($k, $v) = each($_GET) ) {
     if ( is_array($_GET[$k]) ) {
        while( list($k2, $v2) = each($_GET[$k]) ) {
          $return[$k][ clean_key($k2) ] = clean_value($v2);
        }
     }
     else { $return[$k] = clean_value($v); }
   }
 }

 if ( is_array($_POST) ) {

   while( list($k, $v) = each($_POST) ) {
     if ( is_array($_POST[$k]) ) {
        while( list($k2, $v2) = each($_POST[$k]) ) {
          $return[$k][ clean_key($k2) ] = clean_value($v2);
        }
     }
     else { $return[$k] = clean_value($v); }
   }
 }


 $return['IP_ADDRESS'] = select_var( array(
                                            1 => $_SERVER['REMOTE_ADDR'],
                                            2 => $_SERVER['HTTP_X_FORWARDED_FOR'],
                                            3 => $_SERVER['HTTP_PROXY_USER']
                                           )
                                                 );

 // valid IP?

 $return['IP_ADDRESS'] = preg_replace( "/^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})/", "\\1.\\2.\\3.\\4", $return['IP_ADDRESS'] );

 $return['request_method'] = strtolower($_SERVER['REQUEST_METHOD']);

 if ( isset($return['topic']) ) {
         $return['topic'] = intval($return['topic']);
         if ( $return['topic'] == 0 ) die('Hack attempt!');
 }
 if ( isset($return['forum']) ) {
         $return['forum'] = intval($return['forum']);
         if ( $return['forum'] == 0 ) die('Hack attempt!');
 }
    return $return;
}

function clean_key($key) {

 if ($key == '') { return ''; }
 $key = preg_replace( "/\.\./"           , ''  , $key );
 $key = preg_replace( "/\_\_(.+?)\_\_/"  , ''  , $key );
 $key = preg_replace( "/^([\w\.\-\_]+)$/", "$1", $key );
 return $key;
}

function clean_value($val) {

  if ($val == '') { return '';  }
  $val = str_replace( "&#032;"       , ' '             , $val );
  $val = str_replace( "&"            , '&amp;'         , $val );
  $val = str_replace( "<!--"         , '&#60;&#33;--'  , $val );
  $val = str_replace( "-->"          , '--&#62;'       , $val );
  $val = preg_replace( "/<script/i"  , '&#60;script'   , $val );
  $val = str_replace( ">"            , '&gt;'          , $val );
  $val = str_replace( "<"            , '&lt;'          , $val );
  $val = str_replace( "\""           , '&quot;'        , $val );
  $val = preg_replace( "/\n\n/"      , '<p>'           , $val );
  $val = preg_replace( "/\n/"        , '<br>'          , $val );
  $val = preg_replace( "/\\\$/"      , '&#036;'        , $val );
  $val = preg_replace( "/\r/"        , ''              , $val );
  $val = stripslashes($val);
  $val = preg_replace( "/\\\/"       , '&#092;'        , $val );
  return $val;
}

function soft_clr_value($val) {

  if ($val == '') { return '';  }
  $val = str_replace( "&#032;"       , ' '             , $val );
  $val = str_replace( "&"            , '&amp;'         , $val );
  $val = preg_replace( "/<script/i"  , '&#60;script'   , $val );
  $val = str_replace( "\""           , '&quot;'        , $val );
  $val = preg_replace( "/\n\n/"      , '<p>'           , $val );
  $val = preg_replace( "/\n/"        , '<br>'          , $val );
  $val = preg_replace( "/\\\$/"      , '&#036;'        , $val );
  $val = preg_replace( "/\r/"        , ''              , $val );
  $val = stripslashes($val);
  $val = preg_replace( "/\\\/"       , '&#092;'        , $val );
  return $val;
}


function select_var($array) {

 if ( !is_array($array) ) return -1;

 #ksort($array);

 $chosen = -1;

 foreach ($array as $k => $v) {
   if (isset($v)) {
     $chosen = $v;
     break;
   }
 }
 return $chosen;
}

function mark_forum($forumid) {
		global $exbb,$vars,$lang;
		$forumid = intval($forumid);
  		if (empty($forumid)) exit();
  		my_setcookie('f'.$forumid, time() );
  		$url = $exbb['boardurl'].'/forums.php?forum='.$forumid;
  		error($lang['Info'],$lang['Forum_marked'],"<meta http-equiv='refresh' content='3; url=$url'>",0);
}

function mark_board() {
		global $exbb,$lang;

		$_SESSION['last_visit'] = time();
        $fp_user = NULL; $curuserfile 	= $exbb['home_path'].'members/'.$exbb['mem_id'].'.php';
        $curuserdata = Get_File_Data($fp_user,$curuserfile,FALSE);
        $curuserdata['last_visit'] = time();
        save_opened_file($fp_user,$curuserdata);
        unset($curuserdata);

  		$url = $exbb['boardurl'].'/index.php';
  		error($lang['Info'],$lang['Board_marked'],"<meta http-equiv='refresh' content='3; url=$url'>",0);
}

function post_size() {
global $lang,$exbb,$vars;

  if ($vars['request_method'] != 'post') {error($lang['Main_msg'],$lang['Correct_post']);}
  if ( strlen($_POST['inpost']) > $exbb['max_posts'] && !defined('IS_ADMIN') ) {error($lang['Message_sending'],$lang['Big_post']);}
  if ( strlen(trim($_POST['inpost'])) < 1) {error($lang['Message_sending'],$lang['Mess_needed']);}

}

function adminerror($msg_title,$msg_text,$meta = '',$reas = true) {
global $exbb,$lang;

  $title_page = $msg_title;
  if (empty($meta)) $return = ' <a href="javascript:history.go(-1)"> << '.$lang['Back'].'</a>';
  $reasons = ($reas) ? '<b>'.$lang['Reasons'].'</b><ul><li>'.$lang['Wrong_pass'].'<li>'.$lang['Wrong_membername'].'<li><a href="register.php">'.$lang['User_unreg'].'</a></ul>' : '';
  include('./admin/all_header.tpl');
  include('./admin/error.tpl');
  include('./admin/footer.tpl');
  include('page_tail.php');
}

function error($msg_title,$msg_text,$meta = '',$reas = true) {
global $exbb,$lang;

  $title_page = $msg_title;
  if (empty($meta)) $return = ' <a href="javascript:history.go(-1)"> << '.$lang['Back'].'</a>';
  $reasons = ($reas) ? '<b>'.$lang['Reasons'].'</b><ul><li>'.$lang['Wrong_pass'].'<li>'.$lang['Wrong_membername'].'<li><a href="register.php">'.$lang['User_unreg'].'</a></ul>' : '';
  include('./templates/'.$exbb['default_style'].'all_header.tpl');
  include('./templates/'.$exbb['default_style'].'error.tpl');
  include('./templates/'.$exbb['default_style'].'footer.tpl');
  include('page_tail.php');
}

function save_statfile() {
global $exbb;

  $filetomake = $exbb['home_path'].'data/boardstats.php';
  $tofile="<?\n\$exbb['lastreg'] = '$exbb[lastreg]';\n\$exbb['last_id'] = '$exbb[last_id]';\n\$exbb['totalmembers'] = '$exbb[totalmembers]';\n\$exbb['totalthreads'] = '$exbb[totalthreads]';\n\$exbb['totalposts'] = '$exbb[totalposts]';\n?>";
  $fp = @fopen($filetomake, 'w');
  flock($fp,LOCK_EX);
  @fwrite($fp, $tofile);
  fclose($fp);
 @chmod($filetomake ,$exbb['ch_files']);

  return;
}


function replace ($string)
{
$string = str_replace("\n\n",'<p>',$string);
$string = str_replace("\n",'<br>',$string);
$string = str_replace("\t",'',$string);
$string = str_replace("\r",'',$string);
$string = str_replace('  ','',$string);
return $string;
}

function vm($ml = '') {

  $ml = preg_replace( "#[\n\r\*\'\"<>&\%\!\(\)\{\}\[\]\?\\/]#", "", $ml );
  if ( preg_match( "/^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,4}|[0-9]{1,4})(\]?)$/", $ml) ) {
     return $ml;
  }
  else  {
         return FALSE;
        }
}

function seekHttp($rawText)
{
        $pattern=array(
                "#([\t\r\n ])([a-z0-9]+?){1}://([\w\-]+\.([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)#i",
                "#([\t\r\n ])(www|ftp)\.(([\w\-]+\.)*[\w]+(:[0-9]+)?(/[^ \"\n\r\t<]*)?)#i",
                "#([\n ])([a-z0-9\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)*[\w]+)#i");
        $replacement=array(
                '\1<a href="\2://\3" target="_blank">\2://\3</a>',
                '\1<a href="http://\2.\3" target="_blank">\2.\3</a>',
                "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>");
        $ret = ' ' . $rawText;
        $hyperlinkedText=preg_replace($pattern, $replacement, $ret);
        $hyperlinkedText = substr($hyperlinkedText, 1);
        return $hyperlinkedText;
}

function divideWord($content,$maxWordLength = '30') {
   $newContent = wordwrap($content, $maxWordLength, chr(13), 1);
   return $newContent;
}


function longDate($todt,$add = 0) {
global $lang;
  $currDay = strftime ("%d",$todt);
  $currMonth = strftime ("%m",$todt);
  $currYear = strftime ("%Y",$todt);
  $tm = date("H:i:s",$todt);
  #if ($add) { return $tm.' - '.$currDay.' '.$lang[$currMonth].', '.$currYear; }
  return $currDay.' '.$lang['rus_m'][$currMonth].', '.$currYear.' - '.$tm;
}

function joindate($time) {
   $months = array('00' => '','01' => '.','02' => '.','03' => '','04' => '.','05' => '','06' => '','07' => '','08' => '.','09' => '.','10' => '.','11' => '.','12' => '.');
   $currMonth = strftime ("%m",$time);
   $currYear = strftime ("%Y",$time);
   return $months["$currMonth"]." ".$currYear;
}

function my_setcookie($name, $value = "", $exp = 1) {

        $exipres = 0;

        if ($exp == 1) {
                        $expires = time() + 31536000;  #+ year (60*60*24*365 = 31536000)
                } elseif ($exp > 1) {
                        $expires = time() + $exp;  #+ year (60*60*24*365 = 31536000)
        } else {$expires = time() - 1000;}

        @setcookie($name, $value, $expires, '/','');
}



function getlastvisit() {
global $lastvisitinfo;
    $lastvisitinfo = (isset($_COOKIE['f_visits'])) ? unserialize($_COOKIE['f_visits']) : array();
}

function setlastvisit($inforum) {
    $lastvisit = (isset($_COOKIE['f_visits'])) ? unserialize($_COOKIE['f_visits']) : array();
    $lastvisit[$inforum] = time();
    my_setcookie('f_visits',serialize($lastvisit));
}

function set_font($attr) {

  if (!is_array($attr)) return '';

  if ( preg_match( "/;/", $attr['1'] ) ) {
    $attr = explode( ';', $attr['1'] );
    $attr['1'] = $attr[0];
  }

  if ($attr['s'] == 'size') {

    #$attr['1'] = $attr['1'] + 7;
    if ($attr['1'] > 30) $attr['1'] = 30;

    return "<span style='font-size:".$attr['1']."pt;line-height:100%'>".$attr['2']."</span>";
  }
  elseif ($attr['s'] == 'col') {
    $attr['1'] = substr($attr['1'],0,9);
    return "<span style='color:".$attr['1']."'>".stripslashes($attr['2'])."</span>";
  }
  elseif ($attr['s'] == 'font') {
    $attr['1'] = substr($attr['1'],0,9);
    return "<span style='font-family:".$attr['1']."'>".$attr['2']."</span>";
  }
}

function set_code($code="") {
  $code = preg_replace( "#\s{2}#", ' &nbsp;', $code );
  $code = str_replace('<','&lt;',$code);
  $code = str_replace('>','&gt;',$code);
  $code = str_replace('&lt;br&gt;','<br>',$code);
  $code = str_replace(']','&#93;',$code);
  $code = str_replace('[','&#91;',$code);
  $code = str_replace('(','&#40;',$code); //   :) ;) :(
  $code = str_replace(')','&#41;',$code);
  $code = str_replace('&amp;#036;','$',$code);
  $code = str_replace('&amp;quot;','"',$code);
  $code = '<span class=small>:</span><table cellpadding="3" cellspacing="0" width="100%" class="code_table"><tr><td class=code_td>'.$code.'</td></tr></table>';
  return $code;
}

function set_php($code="") {
  $code = str_replace('&lt;','<',$code);
  $code = str_replace('&gt;','>',$code);
  $code = str_replace('<br>',"\n",$code);
  $code = str_replace('<p>',"\n\n",$code);
  $code = str_replace('&amp;','&',$code);
  $code = str_replace('&#036;','$',$code);
  #$code = str_replace('&quot;','"',$code);
  $code = str_replace('&#092;','', $code );
  $code = '<span class=small>PHP:</span><table cellpadding="3" cellspacing="0" width="100%" class="php_table"><tr><td class=php_td>'.highlight_string($code, true).'</td></tr></table>';
  $code = str_replace('(','&#40;',$code); //   :) ;) :(
  $code = str_replace(')','&#41;',$code);
  $code = str_replace(']','&#93;',$code);
  $code = str_replace('[','&#91;',$code);
  return $code;
}

function set_rus($code="") {

  $replace = array ('',    '',   '',   '',   '',   '',   '',   '',   '',   '',  '',  '',  '',  '',  '',   '',  '',   '',   '',  '',  '',  '',  '',  '',  '',  '',  '',  '',   '',   '',   '',  '',  '',   '',  '',  '',   '',  '',   '',    '',  '',   '',  '',  '',  '',  '',  '',  '',  '',  '',  '',  '',  '',  '',  '',  '',  '',  '',  '',  '',  '',  '');
  $search = array ("'Sch'","'Sh'","'Ye'","'Ch'","'Yu'","'Zh'","'Jo'","'Ja'","'ja'","'a'","'b'","'v'","'g'","'d'","'ye'","'e'","'yo'","'zh'","'z'","'i'","'I'","'k'","'l'","'m'","'n'","'o'","'p'","'r'","'sch'","'sh'","'s'","'t'","'yu'","'u'","'f'","'ch'","'h'","'c'","'\'\''","'y'","'\''","'A'","'B'","'V'","'G'","'D'","'E'","'Z'","'I'","'K'","'L'","'M'","'N'","'O'","'P'","'R'","'S'","'T'","'U'","'F'","'H'","'C'");

  return '[s]  [/s]:<br />'.preg_replace ($search, $replace, $code);
}

function replace_img_link($imlink){
		global $exbb,$lang;
        if (@fopen($imlink,"rb")){
			if($size = getimagesize($imlink)){
				if ($size[0] <= 250){
                	$imgtag = "<img src=\"$imlink\" border=\"0\">";
                } else {
						$imgtag = $lang['img_linked']."<a href=\"$imlink\" title=\"".$lang['To_increase']."\" target=\"_blank\"><img src=\"trumbalis.php?mode=link&img=$imlink\" border=\"0\" style=\"border: 1px outset #DCDCDC;\"></a>";
                }
            } else {
					$imgtag = $lang['img_linked']."<a href=\"$imlink\" title=\"".$lang['To_increase']."\" target=\"_blank\"><img src=\"im/images/error404.png\" border=\"0\" style=\"border: 1px outset #DCDCDC;\" ></a>";
            }
        } else {
				$imgtag = $lang['img_linked']."<a href=\"$imlink\" title=\"".$lang['To_increase']."\" target=\"_blank\"><img src=\"im/images/error404.png\" border=\"0\" style=\"border: 1px outset #DCDCDC;\" ></a>";
        }
        return  $imgtag;
}

function ikoncode($post){
        global $exbb;

		$post = str_replace('&quot;','"',$post);
        $post = preg_replace("#<p>#is",'<br><br>', $post);
        $post = str_replace('<br>',' <br> ',$post);

        $post = preg_replace("#\[hr\]#i",'<hr width=40% align=left>',$post);

        $post = preg_replace("#\[code\](.+?)\[/code\]#ies","set_code('\\1')",$post);

        $post = preg_replace("#\[php\](.+?)\[/php\]#ies","set_php('\\1')",$post);
        $post = preg_replace("#\[rus\](.+?)\[/rus\]#ies","set_rus('\\1')",$post);

        while (preg_match( "#\[quote\](.*?)\[/quote\]#is", $post)){
        		$post = preg_replace( "#\[quote\](.*?)\[/quote\]#is"    , "<br><span class=small><b>:</b></span><table cellpadding=3 cellspacing=0 class=q_table><tr><td class=q_td>$1</td></tr></table>",$post);
        }
        while (preg_match( "#\[quote:(.*?)\](.*?)\[/quote\]#is", $post)){
        		$post = preg_replace( "#\[quote:(.*?)\](.*?)\[/quote\]#is"    , "<br><span class=small><b>$1 :</b></span><table cellpadding=3 cellspacing=0 class=q_table><tr><td class=q_td>$2</td></tr></table>",$post);
        }
        while (preg_match( "#\[off\]\s*(.*?)\s*\[/off\]#is", $post)){
        		$post = preg_replace("#\[off\]\s*(.*?)\s*\[/off\]#is","<img src=\"im/emoticons/off.gif\" border=\"0\"><table cellpadding=3 cellspacing=0 class=off_table><tr><td class=off_td>$1</td></tr></table>",$post);
        }
        while (preg_match( "#\[q\]\s*(.*?)\s*\[/q\]#is", $post)){
        		$post = preg_replace("#\[q\]\s*(.*?)\s*\[/q\]#is","<span class=small>:</span><table cellpadding=3 cellspacing=0 width=85% class=q_table><tr><td class=q_td>$1</td></tr></table>",$post);
        }
        $post = preg_replace_callback("#\[email\](.+?)\[/email\]#is",
                        create_function(
                                '$matches',
                                'if (preg_match("#^[a-zA-Z0-9\-_]+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,4}|[0-9]{1,4})(\]?)$#is",$matches[1])) {
                                    return "<a href=\"mailto:".$matches[1]."\">".$matches[1]."</a>";
                                } else {
                                       return "<span style=\"color:red;\">[censored]</span>";
                                }'
                        ),$post);
		if (preg_match_all("#\[url(?:={0,1})(.*?)\](.*?)\[\/url\]#is", $post,$urlmatch, PREG_SET_ORDER)){
            for ($i=0;$i<count($urlmatch);$i++){
            	if (!empty($urlmatch[$i][1]) && (!preg_match("#^(www\.|http://|https://|ftp://|callto://|ed2k://)#is",trim($urlmatch[$i][1]),$urlout) || preg_match("#(.*?)(\<|\>|\]|\[|\s|\`|\'|\"|\(|\)|style(?:%|\s*?)=|javascript(?:%|\s*?):|background-image:url)(.*?)#is", trim($urlmatch[$i][1]),$urlout))){     # || preg_match("#(.*?)(\'|\%|\(|\)|javascript:|background-image:url)(.*?)#is", $urlmatch[$i][2],$urlout)){
                   	$patern[$i] = addcslashes($urlmatch[$i][0],"\|\*\#\%\/\.\?\[\]\&\"\'\:\+\(\)\\\n");
                    $patern[$i]= "#".$patern[$i]."#si";
                    $replace[$i] = "<div style=\"color:red;font-size:10px;\">[ ]</div>";
                } elseif (empty($urlmatch[$i][1]) && (!preg_match("#^(www\.|http://|https://|ftp://|callto://|ed2k://)#is",trim($urlmatch[$i][2]),$urlout) || preg_match("#(.*?)(\<|\>|\]|\[|\s|\`|\'|\"|\(|\)|style(?:%|\s*?)=|javascript(?:%|\s*?):|background-image:url)(.*?)#is", trim($urlmatch[$i][2]),$urlout))){
                		$patern[$i] = addcslashes($urlmatch[$i][0],"\|\*\#\%\/\.\?\[\]\&\"\'\:\+\(\)\\\n");
                        $patern[$i]= "#".$patern[$i]."#si";
                        $replace[$i] = "<div style=\"color:red;font-size:10px;\">[ ]</div>";
                } else {
                  		$patern[$i]= addcslashes($urlmatch[$i][0],"\|\*\#\%\/\.\?\[\]\&\"\'\:\+\(\)\\\n");
                        $patern[$i]= "#".$patern[$i]."#si";
                        #XXXXXXXXXXXXXX    WWW.SITE.RU XXXXXXXXXXXXXXXXXXXXXXX
                        $link = (empty($urlmatch[$i][1]) && !empty($urlmatch[$i][2]))? $urlmatch[$i][2]:$urlmatch[$i][1];
                        $urlecho = "http://";
                        if (preg_match("#(http://|https://|ftp://|callto://|ed2k://)#is",$link)){$urlecho = "";}
                        #XXXXXXXXXXXXXX    WWW.SITE.RU XXXXXXXXXXXXXXXXXXXXXXX
                        $linktext= $urlmatch[$i][2];
                        $replace[$i] = "<a href=\"".$urlecho.trim($link)."\" target=\"_blank\">{$linktext}</a>";
                }
            }
            $post = preg_replace($patern,$replace,$post);
        }

 		$post = preg_replace_callback("#(^|\s)((?:http|https|news|ftp|callto)://\w+[^,\s\[\]\<]+)(,|\s|\<|$)#is",
                		create_function(
                        		'$matches',
                                '$link = $matches[2];
                                if (strlen($matches[2]) > 32) {
                                	$linktext = preg_replace("#^(.{32})(.+)(.{16})#is","$1...$3",trim($matches[2]));
                                    return $matches[1]."<a href=\"$link\" target=\"_blank\">$linktext</a>\n".$matches[3];
                                }
                                return $matches[1]."<a href=\"$link\" target=\"_blank\">$link</a>".$matches[3];'
                        ),$post);
        $post = preg_replace( "#(^|\s)(www\.\w+[^\s\[\]\<]+)#i"  , "$1<a href=\"http://$2\" target=\"_blank\">$2</a>", $post );

        $post = preg_replace("#\[c\](.*?)\[/c\]#is","<center>$1</center>",$post);
        $post = preg_replace("#\[center\](.+?)\[/center\]#is","<center>$1</center>",$post);
        $post = preg_replace("#\[s\](.*?)\[/s\]#is","<span class=\"small\">$1</span>",$post);

        $post = preg_replace( "#\[b\](.+?)\[/b\]#is", "<b>\\1</b>", $post );
        $post = preg_replace( "#\[i\](.+?)\[/i\]#is", "<i>\\1</i>", $post );
        $post = preg_replace( "#\[u\](.+?)\[/u\]#is", "<u>\\1</u>", $post );

        if (preg_match_all("#\[size=(.+?)\](.*?)\[/size\]#ies", $post,$matches1, PREG_SET_ORDER)){
        	for($i=0;$i<count($matches1);$i++){
            	if (!preg_match("#\[size=([0-9]+)\](.+?)\[/size\]#is", $matches1[$i][0],$out1)){
                	$patern1[$i] = addcslashes($matches1[$i][0],"\*\#\%\/\.\?\[\]\&\"\'\:\+\(\)\\\n");
                    $patern1[$i]= "#".$patern1[$i]."#si";
                    $replace1[$i] = "<br><span class=small>[<font color=red>Hack Attempt! The forbidden string  \"<font color=blue>".$matches1[$i][1]."</font>\" is found!</font>]</span><br>".$matches1[$i][2];
                } else {
                		$patern1[$i]= addcslashes($matches1[$i][0],"\*\#\%\/\.\?\[\]\&\"\'\:\+\(\)\\\n");
                        $patern1[$i]= "#".$patern1[$i]."#si";
                        $m1[$i]= $matches1[$i][1];
                        $m2[$i]= $matches1[$i][2];
                        $replace1[$i] = set_font(array('s'=>'size','1'=>$m1[$i],'2'=>$m2[$i]));
                }
            }
            $post = preg_replace($patern1,$replace1,$post);
        }

		while (preg_match( "#\[font=([A-Za-z]{1,9})\](.*?)\[/font\]#ies", $post ) ) {
        		$post = preg_replace( "#\[font=([A-Za-z]{1,9})\](.*?)\[/font\]#ies"    , "set_font(array('s'=>'font','1'=>'\\1','2'=>'\\2'))", $post );
        }

        while (preg_match( "#\[color=([0-9A-Za-z]{2,10})\](.+?)\[/color\]#ies", $post ) ) {
        		$post = preg_replace( "#\[color=([0-9A-Za-z]{2,10})\](.+?)\[/color\]#ies"  , "set_font(array('s'=>'col' ,'1'=>'\\1','2'=>'\\2'))", $post );
        }


        if (preg_match_all("#\[img\](.*?)\[\/img\]#is", $post,$matches, PREG_SET_ORDER)){
        	for($a=0;$a<count($matches);$a++){
            	if (preg_match("#\[img\](.*?)(script:|\'|\`|\?|\&|;|mailto:|\"| |=)(.*?)\[/img\]#is", $matches[$a][0],$out)){
                	$patern[$a]= addcslashes($out[0],"\*\#\%\/\.\?\[\]\&\"\'\:\+\(\)\\\n");
                    $patern[$a]= "#".$patern[$a]."#si";
                    $replace[$a] = "<span class=small>[<font color=red>No dynamic images! The forbidden URL  \"<font color=blue>".$matches[$a][1]."</font>\" is found!</font>]</span>";
                } else {
                		$patern[$a]= addcslashes($matches[$a][0],"\*\#\%\/\.\?\[\]\&\"\'\:\+\(\)\\\n");
                        $patern[$a]= "#".$patern[$a]."#si";
                        $replace[$a] = ($exbb['imgpreview'] == 1) ?replace_img_link($matches[$a][1]):"<img src=".$matches[$a][1].">";
                }
            }
            $post = preg_replace($patern,$replace,$post);
        }

        $post = preg_replace("#(\[list\])(.+?)(\[\/list\])#is","<ul>$2</ul>",$post);
        $post = preg_replace("#(\[list=)(A|1)(\])(.+?)(\[\/list\])#is","<OL TYPE=$2>$4</OL>",$post);
        $post = preg_replace("#(\[\*\])#is","<li>",$post);

        //$post = preg_replace("/(\[FLASH SIZE=1\])(.+?)(\[\/FLASH\])/is","<OBJECT CLASSID='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' WIDTH=80 HEIGHT=60><PARAM NAME=movie VALUE=\"$2\"><PARAM NAME=PLAY VALUE=TRUE><PARAM NAME=LOOP VALUE=TRUE><PARAM NAME=QUALITY VALUE=HIGH><PARAM NAME=scale VALUE=exactfit><PARAM NAME=menu VALUE=false><EMBED src=\"$2\" quality=high menu=false scale=exactfit WIDTH=80 HEIGHT=60 swLiveConnect=true TYPE=\"application/x-shockwave-flash\"></EMBED></OBJECT>",$post);
        //$post = preg_replace("/(\[FLASH SIZE=2\])(.+?)(\[\/FLASH\])/is","<OBJECT CLASSID='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' WIDTH=160 HEIGHT=120><PARAM NAME=movie VALUE=\"$2\"><PARAM NAME=PLAY VALUE=TRUE><PARAM NAME=LOOP VALUE=TRUE><PARAM NAME=QUALITY VALUE=HIGH><PARAM NAME=scale VALUE=exactfit><PARAM NAME=menu VALUE=false><EMBED src=\"$2\" quality=high menu=false scale=exactfit WIDTH=160 HEIGHT=120 swLiveConnect=true TYPE=\"application/x-shockwave-flash\"></EMBED></OBJECT>",$post);
        //$post = preg_replace("/(\[FLASH SIZE=3\])(.+?)(\[\/FLASH\])/is","<OBJECT CLASSID='clsid:D27CDB6E-AE6D-11cf-96B8-444553540000' WIDTH=320 HEIGHT=240><PARAM NAME=movie VALUE=\"$2\"><PARAM NAME=PLAY VALUE=TRUE><PARAM NAME=LOOP VALUE=TRUE><PARAM NAME=QUALITY VALUE=HIGH><PARAM NAME=scale VALUE=exactfit><PARAM NAME=menu VALUE=false><EMBED src=\"$2\" quality=high menu=false scale=exactfit WIDTH=320 HEIGHT=240 swLiveConnect=true TYPE=\"application/x-shockwave-flash\"></EMBED></OBJECT>",$post);
        //$post = preg_replace("/(\[FLASH=)(\S+?)(\,)(.+?)(\])(.+?)(\[\/FLASH\])/is"," <embed src=\"$6\" menu=false scale=exactfit HEIGHT=\"$4\" WIDTH=\"$2\" quality=\"high\"></embed> ",$post);
        //$post = preg_replace("/(\[sound\])(\S+?)(\.mid|\.midi|\.wav)(\[\/sound\])/is","<EMBED SRC=\"$2$3\" AUTOSTART=FALSE LOOP=FALSE WIDTH=100></EMBED> ",$post);

        $post = str_replace(' <br> ','<br>',$post);
        $post = stripslashes($post);
        return $post;
}

function setsmiles($sm) {
static $sm_code,$sm_img;

  if( empty($sm_code) ) {
    $smilies = get_file('./data/smiles.php');
    $sm_code = array();
    $sm_img = array();
    foreach ($smilies as $code=>$data) {
      $code = str_replace(')','\)',$code);
      $code = str_replace('(','\(',$code);
      $sm_code[] = "'$code'";
      $sm_img[] = '<img src="./im/emoticons/'.$data['img'].'" border="0"> ';
    }
  }
  #$sm = str_replace('&quot;','"',$sm);
  return preg_replace($sm_code,$sm_img,$sm);
}

function whosonline($where,$privateID,$show = false) {
		global $exbb,$vars,$lang,$mod_ids,$inuser;

        $output = array("total_users"=>array("guests"=>0,"members"=>0, "hiddens" =>0),"memberoutput"=>array());

    	$currenttime = time();
    	$userexpire = $currenttime - ($exbb['membergone'] * 60);

    	$ip = $vars['IP_ADDRESS'];
    	$b = is_search_bot();
        $sessid = session_id();//ID    

		$fp_online = NULL; $onlinefile = $exbb['home_path'].'data/onlinedata.php';
        $onlinedata = Get_File_Data($fp_online,$onlinefile);

        if ($exbb['reged']) {
        	$st = (in_array($exbb['mem_id'],$mod_ids) ) ? 'mo' : '';
            if (defined('IS_ADMIN')) $st = $exbb['sts'];
        }
        if ($exbb['visiblemode'] == 1) $onlinedata[$sessid]['v'] = (isset($inuser['visible']) && $inuser['visible']===TRUE)?TRUE:FALSE;
        $onlinedata[$sessid]['ip']	= $ip;
        $onlinedata[$sessid]['n']	= $exbb['member'];
    	$onlinedata[$sessid]['id']	= $exbb['mem_id'];
    	$onlinedata[$sessid]['t']	= $currenttime;
    	$onlinedata[$sessid]['in']	= $where;
        $onlinedata[$sessid]['pf']	= $privateID;
		$onlinedata[$sessid]['st']	= $st;
        if (!empty($b)) $onlinedata[$sessid]['b'] = $b;

        $now_online = 0;
    	foreach ($onlinedata as $id=>$info) {
       			if ($userexpire > $info['t']) {
       				unset($onlinedata[$id]);
       				continue;
       			}
                if ((!empty($b) && isset($info['b']) && $b == $info['b']) || ($info['id'] != 0 && $info['n'] == $exbb['member'] && $id !=$sessid)) {
                	unset($onlinedata[$id]);
                	continue;
                }
       			if ($show === TRUE) {
         			switch ($info['id']) {
            			case 0: 	$output['total_users']['guests']++;
            						break 1;
            			default:    if ($exbb['visiblemode'] && isset($info['v']) &&  $info['v']=== TRUE){
                                    	$output['total_users']['hiddens']++;
                                    } else {
                        					$info['n'] = ( $info['st'] == 'ad' ) ? '<font color=red>'.$info['n'].'</font>' : $info['n'];
                        					$info['n'] = ( $info['st'] == 'mo' ) ? '<font color=green>'.$info['n'].'</font>' : $info['n'];
                                			$output['memberoutput'][] = '<a href="profile.php?action=show&member='.$info['id'].'">'.$info['n'].'</a>';
                                    		$output['total_users']['members']++;
                                    }
                					break 1;
         			}
       			}
       			$now_online++;
    	}
        save_opened_file($fp_online,$onlinedata);

    	$max_onlinefile = $exbb['home_path'].'data/max_online.php';
    	$m_online =  @file($max_onlinefile);
    	if (!is_array($m_online)) $m_online = array($currenttime,0);
    	$now_online = array_sum($output['total_users']);
    	if ($m_online[1] < $now_online) {
       		$fp = @fopen($max_onlinefile,'w');
       		@flock($fp,2);
       		@fwrite($fp,$currenttime."\n".$now_online);
       		@fclose($fp);
    	}
        if ($show === TRUE) {
        	$output['memberoutput'] = implode ( ' &raquo; ', $output['memberoutput']);
            return $output;
        }
        unset($output);
		return ;
}

function is_search_bot() {
		$botnamearray	=	array ( 'TurtleScanner','Nutscrape','WebSpeedReader',
                        			'StackRambler','NetCaptor','Yandex',
                         			'Bond','Wget','Space Bison',
                         			'msnbot','Yahoo','Mediapartners-Google',
                         			'Googlebot','Yahoo-MMCrawler','Google',
                         			'Slurp','WebCrawler','ZyBorg','Aport');
		foreach ($botnamearray as $name){
				if (strstr($_SERVER['HTTP_USER_AGENT'], $name)){
					return $name;
					break;
				}
		}
		return '';
}


function max_online(){
global $exbb;

    $filetoopen = $exbb['home_path'].'data/max_online.php';
    $m_online =  @file($filetoopen);
    if ( !is_array($m_online) ) return array(time(),0);
    return $m_online;
}

function bads_filter($check,$replc = 1) {
global $exbb;

     $filetoopen = $exbb['home_path'].'data/badwords.php';
     $badwords = @file($filetoopen);
     unset($badwords[0]);
     if (count($badwords)) {
       $bad = array();
       $good = array();
       foreach ($badwords as $words) {
         list($bw, $gw) = explode('=',$words);
         $bad[] = '/(^|\b)' . trim($bw) . '(\b|!|\?|\.|,|$)/i';
         $good[] = trim($gw);
       }
       if (sizeof($bad)) $ok = preg_replace($bad,$good,$check);
     } else {
         $ok = $check;
     }

     if( $replc ) { return $ok; }
     if ($check != $ok) return true; //  
}

function topic_icon($topic, $read_time=-1) {
global $exbb;

 $icon_path = './templates/'.$exbb['default_style'].'im';

 $read_time = $read_time > $exbb['last_visit'] ? $read_time : $exbb['last_visit'];
 if ($topic['state'] == 'pinned') return '<img src="'.$icon_path.'/folder_sticky.gif" border="0">';
 if ($topic['state'] == 'closed') return '<img src="'.$icon_path.'/locked.gif" border="0">';
 if ($topic['state'] == 'moved') return '<img src="'.$icon_path.'/moved.gif" border="0">';
 if (($topic['posts'] >= $exbb['hot_topic']) and ( (isset($read_time) )  && ($topic['postdate'] <= $read_time ))) return '<img src="'.$icon_path.'/tc_hot.gif" border="0">';
 if ($topic['posts'] >= $exbb['hot_topic']) return '<img src="'.$icon_path.'/to_hot.gif" border="0">';
 if ($read_time  && ($topic['postdate'] > $read_time)) return '<img src="'.$icon_path.'/to_new.gif" border="0">';
 return '<img src="'.$icon_path.'/tc_new.gif" border="0">';

}


function forumjump($allfrm) {
global $exbb,$lang,$jumphtml;
$jumphtml = '
<SCRIPT LANGUAGE="JavaScript">
<!--
function menu(){
var URL = document.jump.jumpto.options[document.jump.jumpto.selectedIndex].value;
top.location.href = URL; target = "_self";
}
// -->
</SCRIPT>
<form action="forums.php" method="post" name="jump">
<select name="jumpto" onchange="menu()">
<option value="index.php">'.$lang['Forum_jump'];
$last_cat = -1;
foreach($allfrm as $forumid=>$val){
  if ($val['catid'] != $last_cat) { #start if $categoryplace
    $jumphtml .= '<option value="'.$exbb['boardurl']."/index.php\">\n";
    $jumphtml .= '<option value="'.$exbb['boardurl'].'/index.php">-- &nbsp; '.$val['catname']."\n";
    $jumphtml .= '<option value="'.$exbb['boardurl'].'/forums.php?forum='.$forumid.'" target="_self"> '.$val['name']."\n";
  } else {
       $jumphtml .= '<option value="'.$exbb['boardurl'].'/forums.php?forum='.$forumid.'" target="_self"> '.$val['name']."\n";
  }
  $last_cat = $val['catid'];
}
$jumphtml .= "</select></form>";
}


function moderator($where,$data) {
global $exbb,$modoutput,$lang,$lang_moder,$mod_ids,$moderators;

  $inmembmod = false;
  $mod_url = array();
  if (!empty($data[$where]['moderator'])) {
    $moderators = unserialize($data[$where]['moderator']);

    foreach ($moderators as $id=>$name) {
      $mod_url[] = '<a href="profile.php?action=show&member='.$id.'">'.$name.'</a>';
      if ($exbb['mem_id'] == $id) $inmembmod = true;
          $mod_ids[] = $id;
    }
  }
  $modoutput = ( count($mod_url) ) ? implode(', ', $mod_url) : $lang['no'];
  $lang_moder = ( count($mod_url) > 1 ) ? $lang['Moderators'] : $lang['Moderator'].':';
  if (defined('IS_ADMIN')) $inmembmod = true;
  return $inmembmod;
}

function sendmail($from_name,$from_address,$message,$subject = '',$to_bcc = array()) {
global $exbb;
  @set_time_limit(600);
  $headers = 'From: '.$from_name.' <'.$from_address.">\n";
  $headers .= 'Reply-To: '.$from_address."\n";
  $headers .= 'Return-Path: '.$from_address."\n";
  $headers .= "MIME-Version: 1.0\nContent-type: text/plain; charset=windows-1251\nContent-Transfer-Encoding: 8bit\nDate: " . gmdate('D, d M Y H:i:s', time()) . " UT\nX-Priority: 3\nX-MSMail-Priority: Normal\nX-Mailer: PHP\n";
  #$to = reset($to_bcc);
  #unset($to_bcc[0]);
  #if (count($to_bcc)) $headers .= 'Bcc: '.implode( ', ' , $to_bcc ) . "\r\n";

  $skip_mails = '';
  if ( ($skip_mails = file($exbb['home_path'].'data/skip_mails.php')) ) {
          unset($skip_mails[0]);
          $skip_mails = implode(':',$skip_mails);

          if ( is_array($to_bcc) ) {
                  $cur_mails = get_file($exbb['home_path'].'data/users.php',FALSE);
                  if ( is_array($cur_mails) ) {
                          foreach ($to_bcc as $id=>$to) {
                                  $domen = substr($cur_mails[$id]['m'],strpos($cur_mails[$id]['m'],'@'));
                                  if (!strstr($skip_mails,$domen)) @mail($cur_mails[$id]['m'], $subject, $message, $headers);
                          }
                  }
          }
          else {
                  $domen = substr($to_bcc,strpos($to_bcc,'@'));
                  if (!strstr($skip_mails,$domen)) @mail($to_bcc, $subject, $message, $headers);
          }
  }
  else {

          if ( is_array($to_bcc) ) {
                  $cur_mails = get_file($exbb['home_path'].'data/users.php',FALSE);
                  if ( is_array($cur_mails) ) {
                          foreach ($to_bcc as $id=>$to) @mail($cur_mails[$id]['m'], $subject, $message, $headers);
                  }
          }
          else {
                  @mail($to_bcc, $subject, $message, $headers);
          }
  }

  unset($headers,$to_bcc,$cur_mails,$subject,$message);
}

function attach_upload($oldid = "",$name = "",$mode = 'post') {
		global $exbb,$lang,$vars;

		$attach = array('attach_id'   => "",
						'attach_file' => "",
				  );

		switch ($_FILES['FILE_UPLOAD']['error'] ) {
				case 1: access_log($exbb['member'] . ' - Failed upload file: the uploaded file exceeds the upload_max_filesize directive in php.ini.'); return $attach; break;
				case 2: access_log($exbb['member'] . ' - Failed upload file: the uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the html form.'); return $attach; break;
				case 3: access_log($exbb['member'] . ' - Failed upload file: the uploaded file was only partially uploaded.'); return $attach; break;
				case 4: return $attach; break;
				default: break;
		}

		$FILE_NAME = trim($_FILES['FILE_UPLOAD']['name']);
		$FILE_SIZE = $_FILES['FILE_UPLOAD']['size'];

		if ($FILE_NAME == "" or !$_FILES['FILE_UPLOAD']['name'] or ($FILE_NAME == 'none') ) {
			return $attach;
		}

		if ($FILE_SIZE > $exbb['uploadsize'] && $FILE_SIZE > 0) {
			access_log($exbb['member'] . ' - Filed upload file: file to big');
			error($lang['Info'],$lang['Attach_tobig'],'',0);
		}

		$FILE_NAME = preg_replace( "/[^\w\.]/", "_", $FILE_NAME);

		if ($mode == 'post') {
			if (!preg_match("#\.(".str_replace(",", "|", $exbb['file_type']).")$#is",$_FILES['FILE_UPLOAD']['name'])) {
				$attach = array();
				return $attach;
			}
			$storage_name = (empty($name)) ? 'file-'.$vars['forum'].'-'.time().'.ext' : $name;
			if ($vars['editattach'] == 'rep'){
				$storage_name = 'file-'.$vars['forum'].'-'.time().'.ext';
			}
			if ($vars['previewfirst'] == 'yes'){
				return array( 'FILE_NAME' => $FILE_NAME );
			}

			$img = false;

			if (preg_match('#image\/[x\-]*([a-z]+)#', $_FILES['FILE_UPLOAD']['type']) && preg_match("#\.(gif|jpg|bmp|png|jpeg|pjpeg)$#is",$_FILES['FILE_UPLOAD']['name'])) {
				list($width, $height) = @getimagesize($_FILES['FILE_UPLOAD']['tmp_name']);
				if ($width > $exbb['img_width'] || $height > $exbb['img_height']){ // $width  $height -     
					$attach = array();
					return $attach;
				}
				$FILE_NAME = uniqid("att-").substr($FILE_NAME,-8);
				$storage_name = $FILE_NAME;
				$img = true;
				$filetoopen = $exbb['home_path'].'uploads/'.$name;
				if ( file_exists($filetoopen) ) @unlink($filetoopen);
			}

			if (! @move_uploaded_file( $_FILES['FILE_UPLOAD']['tmp_name'], $exbb['home_path'].'uploads/'.$storage_name) ){
				access_log($exbb['member'] . ' - Filed upload to: '.$exbb['home_path'].'uploads/'.$storage_name);
				error($lang['Info'],$lang['upload_failed'],'',0);
			} else {
					@chmod( $exbb['home_path'].'uploads/'.$storage_name, $exbb['ch_upfiles'] );
			}

			$fp_attaches = NULL; $attachesfile = $exbb['home_path'].'forum'.$vars['forum'].'/attaches-'.$vars['topic'].'.php';
			$alldata = Get_File_Data($fp_attaches,$attachesfile);
			ksort($alldata,SORT_NUMERIC);
			end($alldata);

			$id = (empty($oldid)) ? key($alldata) + 1 : intval($oldid);
			$alldata[$id]['id'] = $storage_name;
			$alldata[$id]['hits'] =(!empty($oldid))? $alldata[$id]['hits']:0;
			$alldata[$id]['file'] = $FILE_NAME;
			if ($img) $alldata[$id]['size'] = $width.':'.$height;
			if (!$img && isset($alldata[$id]['size'])) unset($alldata[$id]['size']);
			save_opened_file($fp_attaches,$alldata);

			$attach['attach_id']  = $id;
			$attach['attach_file'] = $FILE_NAME;
			return $attach;
		} else {
				preg_match('#image\/[x\-]*([a-z]+)#', $_FILES['FILE_UPLOAD']['type'], $filetype);

				if ( ($types = file($exbb['home_path']. 'im/avatars/personal/types.txt')) ) {
					if ( !strstr($types[0],$filetype[1]) ) {
					     access_log($exbb['member'] . ' - Failed upload avatar: unsupported type - '.$filetype[1].' or type miss in im/avatars/personal/types.txt.');
					     return $attach;
					}
				}

				switch ($filetype[1]) {
					case 'jpeg'	:
					case 'pjpeg':
					case 'jpg'	: 	$type = '.jpg';
									break;
					case 'gif'	: 	$type = '.gif';
                                   	break;
					case 'png'	: 	$type = '.png';
                                   	break;
					case 'bmp'	: 	$type = '.bmp';
									break;
					case 'tiff'	: 	$type = '.tiff';
                                   	break;
					default		: 	access_log($exbb['member'] . ' - Failed upload avatar: unsupported type - '.$filetype[1].' Contact to www.exbb.revansh.com');
									return $attach;
                                   	break;
				}

				if ((isset($_FILES['FILE_UPLOAD']['type'])) && ($_FILES['FILE_UPLOAD']['size'] > $exbb['avatar_size']) ) {
					access_log($exbb['member'] . ' - Failed upload avatar: size to big '.$_FILES['FILE_UPLOAD']['size']);
					return $attach;
				}

				$avatar_name = $exbb['mem_id'] . '-avatar' . $type;
				$storage_name = 'personal/' . $avatar_name;

				list($width, $height) = @getimagesize($_FILES['FILE_UPLOAD']['tmp_name']);

				if ($width <= $exbb['avatar_max_width'] && $height <= $exbb['avatar_max_height']) {
					if (@move_uploaded_file( $_FILES['FILE_UPLOAD']['tmp_name'], $exbb['home_path']. 'im/avatars/' .$storage_name) ) {
						@chmod( $exbb['home_path'] . 'im/avatars/' . $storage_name, $exbb['ch_upfiles'] );
						$attach['attach_file'] = $storage_name;
						if ( ($loaded = get_dir($exbb['home_path'] . 'im/avatars/personal/',$exbb['mem_id'] . '-avatar.*')) ) {
							foreach ($loaded as $trash) if ($trash != $avatar_name) @unlink($exbb['home_path'] . 'im/avatars/personal/' . $trash);
						}
						return $attach;
					}
					$attach['attach_file'] = $name;
					access_log($exbb['member'] . ' - Failed upload avatar: server can not move file to '.$exbb['home_path'] . 'im/avatars/personal/. Check chmod to dirs.');
					return $attach;
				}
		}
}

function sort_by_catid($a, $b) {
    if ($a['catid'] == $b['catid']) return 0;
    return ($a['catid'] < $b['catid']) ? -1 : 1;
}
function sort_by_position($a, $b) {
    if ($a['position'] == $b['position']) return 0;
    return ($a['position'] < $b['position']) ? -1 : 1;
}

function sort_by_postdate($a, $b) {
    if ($a['postdate'] == $b['postdate']) return 0;
    return ($a['postdate'] > $b['postdate']) ? -1 : 1;
}


function save_file($filename,$arr){
		global $exbb;

		$fp = fopen($filename,'w');
  		lock_file($fp,$filename,LOCK_EX);
  		fwrite($fp,'<?die;?>'.serialize($arr));
  		fclose($fp);
 		@chmod($filename,$exbb['ch_files']);
}

function save_opened_file(&$pointer,$arr) {
  		fseek ($pointer,0);
  		ftruncate ($pointer,0);
  		fwrite($pointer,'<?die;?>'.serialize($arr));
  		fflush($pointer);
  		@flock($pointer,3);
  		fclose($pointer);
  		unset($arr);
  		return;
}

function prints($arr = array()) {
		echo '<pre>';
		print_r($arr);
		echo '</pre>';
		return;
}

function get_file($filename,$newfile = TRUE) {
        global $exbb;
        if ($newfile === TRUE) {
			fclose(fopen($filename,"a+"));
        }
        @chmod($filename,$exbb['ch_files']);
        $fp = fopen($filename,'r');
        lock_file($fp,$filename);
        $filesize = filesize($filename);
        $filesize = ($filesize ===0) ? 1:$filesize-8;
        fseek($fp,8);
        $str = fread($fp,$filesize);
        fclose($fp);
        return (!empty($str))?unserialize($str):array();
}

function lock_file(&$file,$filename,$mode = LOCK_SH) {
		if (preg_match('/[c-z]:\\\.*/i', $_SERVER['PATH'])) return;
  		$i = 0;
  		while (!flock($file,$mode+LOCK_NB)) {
      		sleep(1);
      		$i++;
      		if ($i>=10) {
          		@fclose($file);
                $_POST['inpost'] = (isset($_POST['inpost']))? '<br>You may save your message:<br>'.htmlspecialchars($_POST['inpost']):'';
          		die('Access to file '.$filename.' blocked! Try again later'.$_POST['inpost']);
      		}
  		}
}

function get_dir($path = './', $mask = '*.php', $mode = GLOB_NOSORT) {
        global $exbb;

        if ( version_compare( phpversion(), '4.3.0', '>=' ) ) {
                if ( chdir($path) ) {
                        $temp = glob($mask,$mode);
                        chdir($exbb['home_path']);
                        return $temp;
                }
        }
        return false;

}

function return_IP() {

		$first = isset($_SERVER['REMOTE_ADDR']) ? $_SERVER['REMOTE_ADDR']:Null;
		$second = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR']:NULL;
		$third = isset($_SERVER['HTTP_PROXY_USER']) ? $_SERVER['HTTP_PROXY_USER']:NULL;
		$array = array(1 => $first,2 => $second,3 => $third );

		if (!is_array($array)) return -1;
		$chosen = -1;
        foreach ($array as $k => $v) {
				if (isset($v)) {
                	$chosen = $v;
                    break;
                }
        }
        return preg_replace( "/^([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})/", "\\1.\\2.\\3.\\4", $chosen );
}

/*
	Changes from 16.03.2006
*/

function Get_File_Data(&$fp,$filename,$newfile = TRUE) {
        global $exbb;
        if ($newfile === TRUE) {
			fclose(fopen($filename,"a+"));
        }
        @chmod($filename,$exbb['ch_files']);
        $fp = fopen($filename,'r+');
        lock_file($fp,$filename,LOCK_EX);
        $filesize = filesize($filename);
        $filesize = ($filesize ===0) ? 1:$filesize-8;
        fseek($fp,8);
        $str = fread($fp,$filesize);
        return (!empty($str))?unserialize($str):array();
}
/*
	Filter for new post
*/
function NEW_POSTS($var){
		global $exbb,$id,$f_readed,$t_visits;
        $top_id = $id.':'.$var['id'];
        $t_readed = isset($t_visits[$top_id])? $t_visits[$top_id]:0;
		return ($var['postdate'] >= $f_readed && $var['postdate'] > $t_readed && $var['p_id'] != $exbb['mem_id']) ?1:0;
}
/*
	Check poll
*/
function isset_poll($f_id,$pol_id){
		global $exbb;
		$pollfile = $exbb['home_path'].'forum'.$f_id.'/'.$pol_id.'-poll.php';
		if (!file_exists($pollfile)) return FALSE;
		$poldata = get_file($pollfile,FALSE);
		if (count($poldata)===0) return FALSE;
		return TRUE;
}
/*
	Generate_pass
*/
function Generate_pass(){
		$shufflestring	= str_shuffle('QqWwEeRrTtYyUuIiOoPpAaSsDdFfGgHhJjKkLlZzXxCcVvBbNnMm0123456789');
        $uniqstring		= uniqid($shufflestring, false);
 		$newpassword = substr($uniqstring, mt_rand(0,40),8);
        return $newpassword;
}
/*
	For fix zeros bugs
*/
function send_bugs($_FILE,$_LINE,$file_array,$mode) {
         global $exbb,$vars,$lang;
         $zeros = array();
         $mode_array = array(1 => "   ,  ".$exbb['member'].",",
         					 2 => "  ,  ".$exbb['member'].",",
         					 3 => " ,  ".$exbb['member'].",",
         					 4 => "    ,  ".$exbb['member'].",",
         					 5 => " ,  ".$exbb['member'].",",
         					 6 => " ,  ".$exbb['member'].",",
         					 7 => "  ,  ".$exbb['member'].",",
         					 8 => " ,  ".$exbb['member'].",",
         					 9 => " ,  ".$exbb['member'].",",
         					 10 => "  ,  ".$exbb['member'].",",
         					 11 => " ,  ".$exbb['member'].",",
         					 12 => " ,  ".$exbb['member'].",",
         					 13 => "  ,  ".$exbb['member'].",",
         					 14 => "  ,  ".$exbb['member'].",",
         					 15 => "   ,  ".$exbb['member'].",",
         					 16 => "/ ,  ".$exbb['member'].",",
         					 17 => "   ".$exbb['member'].",",
         					 18 => "  \"\"",
         					 19 => "  ,  ".$exbb['member'].",",
                             20 => "  ,  ".$exbb['member'].",",
                             21 => "   ,  ".$exbb['member'].",",
                             22 => "   ,  ".$exbb['member'].",",
                             23 => "     ,  ".$exbb['member'].",",
                             24 => "      ,  ".$exbb['member'].",",
                             25 => "  ,  ".$exbb['member'].",",
                             26 => "  ,  ".$exbb['member'].",",
                             27 => " ,  ".$exbb['member'].",",
                             28 => "    ,  ".$exbb['member'].",",
                             29 => "  ,  ".$exbb['member'].","
         					 );
         foreach ($file_array as $file) {
                $basename = basename($file);
                $size = ($basename == 'views.php') ? 14:40;
	     		if(!empty($file) && filesize($file) < $size) {
	     			$zeros[] = $file;
	     		}
	     }

         if (count($zeros) > 0) {
         	$message = "  \n  ".$mode_array[$mode]."    :\n";
            $message .= implode("\n",$zeros);
            $message .= "\n      ".$_FILE."   ".$_LINE." \n";
            $message .= "\n    ,       ExBB (http://tvoyweb.ru/forums)   .\n";
            $message .= "\n\n\n ,   ExBB";
         	sendmail($exbb['boardname'],"exbbbugreport@tvoyweb.ru",$message," ",$exbb['adminemail']);
         }
         unset($zeros,$mode_array);
         return;
}
function Check_DefLang() {
  global $exbb, $vars;
 
  $temp_ar = array();
  $dirtoopen = $exbb['home_path'].'language';
  if (!($temp_ar = get_dir($dirtoopen,'*',GLOB_ONLYDIR))) {
   $handle = opendir($dirtoopen);
   while (($file = @readdir($handle))!==false) {
    if (is_dir($exbb['home_path'].'language/'.$file) && $file != '.' && $file != '..') {
     $temp_ar[] = $file;
    }
   }
   closedir($handle);
  }
  return (array_search($vars['default_lang'], $temp_ar) !== FALSE) ? $vars['default_lang']:$exbb['default_lang'];
}
?>
